var Dom, View, cache, minify, modelHelper, uglify;
uglify = require('uglify-js');
module.exports = View = require('./View');
Dom = require('./Dom');
modelHelper = require('./modelHelper');
View.prototype._register = function(name, fn) {
  return this._views[name] = fn;
};
View.prototype.sendHtml = function(res, model) {
  var clientName, doctype, dom, head, initEnd, initStart, tail, title;
  dom = this.dom = new Dom(this.model = modelHelper.init(model));
  this._idCount = 0;
  if (!res.getHeader('content-type')) {
    res.setHeader('Content-Type', 'text/html; charset=utf-8');
  }
  doctype = this.get('Doctype') || '<!DOCTYPE html><meta charset=utf-8>';
  title = this.get('Title') || 'Derby app';
  head = this.get('Head');
  res.write("" + doctype + "<title>" + title + "</title>" + head);
  res.write(this.get('Body'));
  clientName = this._clientName;
  res.write("<script>function $(i){return document.getElementById(i)}" + ("function " + clientName + "(){" + clientName + "=1}") + ("" + (minify(this._loadFuncs)) + "</script>") + ("<script defer async onload=" + clientName + "() src=" + this._jsFile + "></script>"));
  tail = this.get('Tail');
  initStart = "<script>(function(){function f(){setTimeout(function(){" + ("" + clientName + "=require('./" + clientName + "')(") + this._idCount + ',';
  initEnd = ")},0)}" + clientName + "===1?f():" + clientName + "=f})()</script>" + tail;
  return model.bundle(function(bundle) {
    return res.end(initStart + bundle.replace(/<\//g, '<\\/') + ',' + JSON.stringify(model.__events.get()) + ',' + JSON.stringify(dom.events.get()) + initEnd);
  });
};
cache = {};
minify = function(js) {
  if (cache[js]) {
    return cache[js];
  }
  return cache[js] = uglify(js);
};