var View, crypto, fs, path, racer;
racer = require('racer');
View = require('./View.server');
path = require('path');
fs = require('fs');
crypto = require('crypto');
exports.createApp = function(appModule, appExports, options) {
  var bundle, staticDir, staticPath, staticRoot, view;
  if (options == null) {
    options = {};
  }
  racer.util.merge(appExports, racer);
  appExports.view = view = new View;
  appExports.ready = function() {};
  view._clientName = options.name || path.basename(appModule.filename, '.js');
  staticRoot = options.root || path.dirname(appModule.filename);
  staticDir = options.dir || 'public';
  staticPath = path.join(staticRoot, staticDir);
  bundle = function() {
    return racer.js({
      require: appModule.filename
    }, function(js) {
      var filePath, filename;
      filename = crypto.createHash('md5').update(js).digest('base64') + '.js';
      view._jsFile = filename = filename.replace(/[\/\+=]/g, function(match) {
        switch (match) {
          case '/':
            return '-';
          case '+':
            return '_';
          case '=':
            return '';
        }
      });
      filePath = path.join(staticPath, filename);
      return fs.writeFile(filePath, js);
    });
  };
  path.exists(staticPath, function(exists) {
    if (exists) {
      return bundle();
    }
    return fs.mkdir(staticPath, 0777, function(err) {
      if (err) {
        throw err;
      }
      return bundle();
    });
  });
  return appExports;
};