module.exports = function(view, events) {
  return {
    elementPlaceholder: {
      input: function(attr, attrs, name) {
        var method, silent;
        if (attr !== 'value') {
          return 'attr';
        }
        if ('silent' in attrs) {
          delete attrs.silent;
          method = 'prop';
          silent = 1;
        } else {
          method = 'propPolite';
          silent = 0;
        }
        events.push(function(data, modelEvents, domEvents) {
          var domArgs;
          domArgs = ['set', data[name].model, attrs._id || attrs.id, 'prop', 'value', silent];
          domEvents.bind('keyup', domArgs);
          return domEvents.bind('keydown', domArgs);
        });
        return method;
      }
    },
    elementBind: {
      a: function(attrs, name) {
        if (name === 'click') {
          if (!attrs.href) {
            attrs.href = '#';
          }
          if (!attrs.onclick) {
            return attrs.onclick = 'return false';
          }
        }
      },
      form: function(attrs, name) {
        if (name === 'submit') {
          if (!attrs.onsubmit) {
            return attrs.onsubmit = 'return false';
          }
        }
      }
    }
  };
};