var EventDispatcher;
EventDispatcher = require('./EventDispatcher');
exports.init = function(model, dom, view) {
  var event, events, get, _fn, _i, _len, _ref;
  get = model.get;
  events = model.__events = new EventDispatcher({
    onTrigger: function(path, listener, value, options) {
      var id, method, oldPath, partial, property;
      oldPath = listener[0], id = listener[1], method = listener[2], property = listener[3], partial = listener[4];
      if (!(oldPath === path || get(oldPath) === get(path))) {
        return false;
      }
      if (options && options.method) {
        method = options.method;
      }
      if (partial) {
        value = view.get(partial, value);
      }
      return dom.update(id, method, property, value);
    },
    onBind: function(path, listener) {
      return listener.unshift(path);
    }
  });
  model.on('set', function(_arg) {
    var path, value;
    path = _arg[0], value = _arg[1];
    return events.trigger(path, value);
  });
  model.on('push', function(_arg) {
    var path, value;
    path = _arg[0], value = _arg[1];
    return events.trigger(path, value, {
      method: 'appendHtml'
    });
  });
  _ref = ['connected', 'canConnect'];
  _fn = function(event) {
    return model.on(event, function(value) {
      return events.trigger(event, value);
    });
  };
  for (_i = 0, _len = _ref.length; _i < _len; _i++) {
    event = _ref[_i];
    _fn(event);
  }
  return model;
};